4ebaf07c13e5ae37a8cb70124a4870fda726b1ef
[arvados.git] / build / run-tests.sh
1 #!/bin/bash
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 . `dirname "$(readlink -f "$0")"`/libcloud-pin.sh
7
8 COLUMNS=80
9 . `dirname "$(readlink -f "$0")"`/run-library.sh
10
11 read -rd "\000" helpmessage <<EOF
12 $(basename $0): Install and test Arvados components.
13
14 Exit non-zero if any tests fail.
15
16 Syntax:
17         $(basename $0) WORKSPACE=/path/to/arvados [options]
18
19 Options:
20
21 --skip FOO     Do not test the FOO component.
22 --only FOO     Do not test anything except the FOO component.
23 --temp DIR     Install components and dependencies under DIR instead of
24                making a new temporary directory. Implies --leave-temp.
25 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
26                Instead, show the path to give as --temp to reuse them in
27                subsequent invocations.
28 --repeat N     Repeat each install/test step until it succeeds N times.
29 --retry        Prompt to retry if an install or test suite fails.
30 --skip-install Do not run any install steps. Just run tests.
31                You should provide GOPATH, GEMHOME, and VENVDIR options
32                from a previous invocation if you use this option.
33 --only-install Run specific install step
34 --short        Skip (or scale down) some slow tests.
35 WORKSPACE=path Arvados source tree to test.
36 CONFIGSRC=path Dir with api server config files to copy into source tree.
37                (If none given, leave config files alone in source tree.)
38 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
39                Restrict apiserver tests to the given file
40 sdk/python_test="--test-suite test.test_keep_locator"
41                Restrict Python SDK tests to the given class
42 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
43                Restrict Workbench tests to the given file
44 services/arv-git-httpd_test="-check.vv"
45                Show all log messages, even when tests pass (also works
46                with services/keepstore_test etc.)
47 ARVADOS_DEBUG=1
48                Print more debug messages
49 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
50                *_test, and other examples shown above.
51
52 Assuming --skip-install is not given, all components are installed
53 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
54 test suites depend on other components being installed, and installing
55 everything tends to be quicker than debugging dependencies.
56
57 As a special concession to the current CI server config, CONFIGSRC
58 defaults to $HOME/arvados-api-server if that directory exists.
59
60 More information and background:
61
62 https://arvados.org/projects/arvados/wiki/Running_tests
63
64 Available tests:
65
66 apps/workbench (*)
67 apps/workbench_units (*)
68 apps/workbench_functionals (*)
69 apps/workbench_integration (*)
70 apps/workbench_benchmark
71 apps/workbench_profile
72 cmd/arvados-client
73 doc
74 lib/cli
75 lib/cmd
76 lib/crunchstat
77 services/api
78 services/arv-git-httpd
79 services/crunchstat
80 services/dockercleaner
81 services/fuse
82 services/health
83 services/keep-web
84 services/keepproxy
85 services/keepstore
86 services/keep-balance
87 services/login-sync
88 services/nodemanager
89 services/nodemanager_integration
90 services/crunch-run
91 services/crunch-dispatch-local
92 services/crunch-dispatch-slurm
93 services/ws
94 sdk/cli
95 sdk/pam
96 sdk/python
97 sdk/python:py3
98 sdk/ruby
99 sdk/go/arvados
100 sdk/go/arvadosclient
101 sdk/go/dispatch
102 sdk/go/keepclient
103 sdk/go/health
104 sdk/go/httpserver
105 sdk/go/manifest
106 sdk/go/blockdigest
107 sdk/go/asyncbuf
108 sdk/go/stats
109 sdk/go/crunchrunner
110 sdk/cwl
111 sdk/R
112 tools/sync-groups
113 tools/crunchstat-summary
114 tools/keep-exercise
115 tools/keep-rsync
116 tools/keep-block-check
117
118 (*) apps/workbench is shorthand for apps/workbench_units +
119     apps/workbench_functionals + apps/workbench_integration
120
121 EOF
122
123 # First make sure to remove any ARVADOS_ variables from the calling
124 # environment that could interfere with the tests.
125 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
126
127 # Reset other variables that could affect our [tests'] behavior by
128 # accident.
129 GITDIR=
130 GOPATH=
131 VENVDIR=
132 VENV3DIR=
133 PYTHONPATH=
134 GEMHOME=
135 PERLINSTALLBASE=
136 R_LIBS=
137
138 short=
139 only_install=
140 temp=
141 temp_preserve=
142
143 clear_temp() {
144     if [[ -z "$temp" ]]; then
145         # we didn't even get as far as making a temp dir
146         :
147     elif [[ -z "$temp_preserve" ]]; then
148         rm -rf "$temp"
149     else
150         echo "Leaving behind temp dirs in $temp"
151     fi
152 }
153
154 fatal() {
155     clear_temp
156     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
157     exit 1
158 }
159
160 exit_cleanly() {
161     trap - INT
162     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
163     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
164     stop_services
165     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
166     report_outcomes
167     clear_temp
168     exit ${#failures}
169 }
170
171 sanity_checks() {
172     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
173         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
174     echo Checking dependencies:
175     echo -n 'virtualenv: '
176     virtualenv --version \
177         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
178     echo -n 'ruby: '
179     ruby -v \
180         || fatal "No ruby. Install >=2.1.9 (using rbenv, rvm, or source)"
181     echo -n 'go: '
182     go version \
183         || fatal "No go binary. See http://golang.org/doc/install"
184     [[ $(go version) =~ go1.([0-9]+) ]] && [[ ${BASH_REMATCH[1]} -ge 8 ]] \
185         || fatal "Go >= 1.8 required. See http://golang.org/doc/install"
186     echo -n 'gcc: '
187     gcc --version | egrep ^gcc \
188         || fatal "No gcc. Try: apt-get install build-essential"
189     echo -n 'fuse.h: '
190     find /usr/include -path '*fuse/fuse.h' | egrep --max-count=1 . \
191         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
192     echo -n 'gnutls.h: '
193     find /usr/include -path '*gnutls/gnutls.h' | egrep --max-count=1 . \
194         || fatal "No gnutls/gnutls.h. Try: apt-get install libgnutls28-dev"
195     echo -n 'Python2 pyconfig.h: '
196     find /usr/include -path '*/python2*/pyconfig.h' | egrep --max-count=1 . \
197         || fatal "No Python2 pyconfig.h. Try: apt-get install python2.7-dev"
198     echo -n 'Python3 pyconfig.h: '
199     find /usr/include -path '*/python3*/pyconfig.h' | egrep --max-count=1 . \
200         || fatal "No Python3 pyconfig.h. Try: apt-get install python3-dev"
201     echo -n 'nginx: '
202     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
203         || fatal "No nginx. Try: apt-get install nginx"
204     echo -n 'perl: '
205     perl -v | grep version \
206         || fatal "No perl. Try: apt-get install perl"
207     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
208         echo -n "perl $mod: "
209         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
210             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
211     done
212     echo -n 'gitolite: '
213     which gitolite \
214         || fatal "No gitolite. Try: apt-get install gitolite3"
215     echo -n 'npm: '
216     npm --version \
217         || fatal "No npm. Try: wget -O- https://nodejs.org/dist/v6.11.2/node-v6.11.2-linux-x64.tar.xz | sudo tar -C /usr/local -xJf - && sudo ln -s ../node-v6.11.2-linux-x64/bin/{node,npm} /usr/local/bin/"
218     echo -n 'cadaver: '
219     cadaver --version | grep -w cadaver \
220           || fatal "No cadaver. Try: apt-get install cadaver"
221     echo -n 'libattr1 xattr.h: '
222     find /usr/include -path '*/attr/xattr.h' | egrep --max-count=1 . \
223         || fatal "No libattr1 xattr.h. Try: apt-get install libattr1-dev"
224     echo -n 'libcurl curl.h: '
225     find /usr/include -path '*/curl/curl.h' | egrep --max-count=1 . \
226         || fatal "No libcurl curl.h. Try: apt-get install libcurl4-gnutls-dev"
227     echo -n 'libpq libpq-fe.h: '
228     find /usr/include -path '*/postgresql/libpq-fe.h' | egrep --max-count=1 . \
229         || fatal "No libpq libpq-fe.h. Try: apt-get install libpq-dev"
230     echo -n 'services/api/config/database.yml: '
231     if [[ ! -f "$WORKSPACE/services/api/config/database.yml" ]]; then
232             fatal "Please provide a database.yml file for the test suite"
233     else
234             echo "OK"
235     fi
236     echo -n 'postgresql: '
237     psql --version || fatal "No postgresql. Try: apt-get install postgresql postgresql-client-common"
238     echo -n 'phantomjs: '
239     phantomjs --version || fatal "No phantomjs. Try: apt-get install phantomjs"
240     echo -n 'xvfb: '
241     which Xvfb || fatal "No xvfb. Try: apt-get install xvfb"
242     echo -n 'graphviz: '
243     dot -V || fatal "No graphviz. Try: apt-get install graphviz"
244
245     # R SDK stuff
246     echo -n 'R: '
247     which R || fatal "No R. Try: apt-get install r-base"
248     echo -n 'testthat: '
249     R -q -e "library('testthat')" || fatal "No testthat. Try: apt-get install r-cran-testthat"
250     # needed for roxygen2, needed for devtools, needed for R sdk
251     pkg-config --exists libxml-2.0 || fatal "No libxml2. Try: apt-get install libxml2-dev"
252 }
253
254 rotate_logfile() {
255   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
256   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
257   if [[ -f "$1/$2" ]]; then
258     THEDATE=`date +%Y%m%d%H%M%S`
259     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
260     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
261   fi
262 }
263
264 declare -a failures
265 declare -A skip
266 declare -A testargs
267 skip[apps/workbench_profile]=1
268
269 while [[ -n "$1" ]]
270 do
271     arg="$1"; shift
272     case "$arg" in
273         --help)
274             echo >&2 "$helpmessage"
275             echo >&2
276             exit 1
277             ;;
278         --skip)
279             skip[$1]=1; shift
280             ;;
281         --only)
282             only="$1"; skip[$1]=""; shift
283             ;;
284         --short)
285             short=1
286             ;;
287         --skip-install)
288             only_install=nothing
289             ;;
290         --only-install)
291             only_install="$1"; shift
292             ;;
293         --temp)
294             temp="$1"; shift
295             temp_preserve=1
296             ;;
297         --leave-temp)
298             temp_preserve=1
299             ;;
300         --repeat)
301             repeat=$((${1}+0)); shift
302             ;;
303         --retry)
304             retry=1
305             ;;
306         *_test=*)
307             suite="${arg%%_test=*}"
308             args="${arg#*=}"
309             testargs["$suite"]="$args"
310             ;;
311         *=*)
312             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
313             ;;
314         *)
315             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
316             exit 1
317             ;;
318     esac
319 done
320
321 start_services() {
322     echo 'Starting API, keepproxy, keep-web, ws, arv-git-httpd, and nginx ssl proxy...'
323     if [[ ! -d "$WORKSPACE/services/api/log" ]]; then
324         mkdir -p "$WORKSPACE/services/api/log"
325     fi
326     # Remove empty api.pid file if it exists
327     if [[ -f "$WORKSPACE/tmp/api.pid" && ! -s "$WORKSPACE/tmp/api.pid" ]]; then
328         rm -f "$WORKSPACE/tmp/api.pid"
329     fi
330     cd "$WORKSPACE" \
331         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
332         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
333         && export ARVADOS_TEST_API_INSTALLED="$$" \
334         && python sdk/python/tests/run_test_server.py start_keep_proxy \
335         && python sdk/python/tests/run_test_server.py start_keep-web \
336         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
337         && python sdk/python/tests/run_test_server.py start_ws \
338         && python sdk/python/tests/run_test_server.py start_nginx \
339         && (env | egrep ^ARVADOS)
340 }
341
342 stop_services() {
343     if [[ -z "$ARVADOS_TEST_API_HOST" ]]; then
344         return
345     fi
346     unset ARVADOS_TEST_API_HOST
347     cd "$WORKSPACE" \
348         && python sdk/python/tests/run_test_server.py stop_nginx \
349         && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
350         && python sdk/python/tests/run_test_server.py stop_ws \
351         && python sdk/python/tests/run_test_server.py stop_keep-web \
352         && python sdk/python/tests/run_test_server.py stop_keep_proxy \
353         && python sdk/python/tests/run_test_server.py stop
354 }
355
356 interrupt() {
357     failures+=("($(basename $0) interrupted)")
358     exit_cleanly
359 }
360 trap interrupt INT
361
362 sanity_checks
363
364 echo "WORKSPACE=$WORKSPACE"
365
366 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
367     # Jenkins expects us to use this by default.
368     CONFIGSRC="$HOME/arvados-api-server"
369 fi
370
371 # Clean up .pyc files that may exist in the workspace
372 cd "$WORKSPACE"
373 find -name '*.pyc' -delete
374
375 if [[ -z "$temp" ]]; then
376     temp="$(mktemp -d)"
377 fi
378
379 # Set up temporary install dirs (unless existing dirs were supplied)
380 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE R_LIBS
381 do
382     if [[ -z "${!tmpdir}" ]]; then
383         eval "$tmpdir"="$temp/$tmpdir"
384     fi
385     if ! [[ -d "${!tmpdir}" ]]; then
386         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
387     fi
388 done
389
390 setup_ruby_environment() {
391     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
392         source "$HOME/.rvm/scripts/rvm"
393         using_rvm=true
394     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
395         source "/usr/local/rvm/scripts/rvm"
396         using_rvm=true
397     else
398         using_rvm=false
399     fi
400
401     if [[ "$using_rvm" == true ]]; then
402         # If rvm is in use, we can't just put separate "dependencies"
403         # and "gems-under-test" paths to GEM_PATH: passenger resets
404         # the environment to the "current gemset", which would lose
405         # our GEM_PATH and prevent our test suites from running ruby
406         # programs (for example, the Workbench test suite could not
407         # boot an API server or run arv). Instead, we have to make an
408         # rvm gemset and use it for everything.
409
410         [[ `type rvm | head -n1` == "rvm is a function" ]] \
411             || fatal 'rvm check'
412
413         # Put rvm's favorite path back in first place (overriding
414         # virtualenv, which just put itself there). Ignore rvm's
415         # complaint about not being in first place already.
416         rvm use @default 2>/dev/null
417
418         # Create (if needed) and switch to an @arvados-tests-* gemset,
419         # salting the gemset name so it doesn't interfere with
420         # concurrent builds in other workspaces. Leave the choice of
421         # ruby to the caller.
422         gemset="arvados-tests-$(echo -n "${WORKSPACE}" | md5sum | head -c16)"
423         rvm use "@${gemset}" --create \
424             || fatal 'rvm gemset setup'
425
426         rvm env
427     else
428         # When our "bundle install"s need to install new gems to
429         # satisfy dependencies, we want them to go where "gem install
430         # --user-install" would put them. (However, if the caller has
431         # already set GEM_HOME, we assume that's where dependencies
432         # should be installed, and we should leave it alone.)
433
434         if [ -z "$GEM_HOME" ]; then
435             user_gempath="$(gem env gempath)"
436             export GEM_HOME="${user_gempath%%:*}"
437         fi
438         PATH="$(gem env gemdir)/bin:$PATH"
439
440         # When we build and install our own gems, we install them in our
441         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
442         # PATH so integration tests prefer them over other versions that
443         # happen to be installed in $user_gempath, system dirs, etc.
444
445         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
446         PATH="$tmpdir_gem_home/bin:$PATH"
447         export GEM_PATH="$tmpdir_gem_home"
448
449         echo "Will install dependencies to $(gem env gemdir)"
450         echo "Will install arvados gems to $tmpdir_gem_home"
451         echo "Gem search path is GEM_PATH=$GEM_PATH"
452     fi
453     bundle config || gem install bundler \
454         || fatal 'install bundler'
455 }
456
457 with_test_gemset() {
458     if [[ "$using_rvm" == true ]]; then
459         "$@"
460     else
461         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
462     fi
463 }
464
465 gem_uninstall_if_exists() {
466     if gem list "$1\$" | egrep '^\w'; then
467         gem uninstall --force --all --executables "$1"
468     fi
469 }
470
471 setup_virtualenv() {
472     local venvdest="$1"; shift
473     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
474         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
475     fi
476     if [[ $("$venvdest/bin/python" --version 2>&1) =~ \ 3\.[012]\. ]]; then
477         # pip 8.0.0 dropped support for python 3.2, e.g., debian wheezy
478         "$venvdest/bin/pip" install 'setuptools>=18.5' 'pip>=7,<8'
479     else
480         "$venvdest/bin/pip" install 'setuptools>=18.5' 'pip>=7'
481     fi
482     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
483     "$venvdest/bin/pip" install 'mock>=1.0' 'pbr<1.7.0'
484 }
485
486 export PERLINSTALLBASE
487 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
488
489 export R_LIBS
490
491 export GOPATH
492 mkdir -p "$GOPATH/src/git.curoverse.com"
493 rmdir -v --parents --ignore-fail-on-non-empty "$GOPATH/src/git.curoverse.com/arvados.git/tmp/GOPATH"
494 for d in \
495     "$GOPATH/src/git.curoverse.com/arvados.git/arvados.git" \
496     "$GOPATH/src/git.curoverse.com/arvados.git"; do
497     [[ -d "$d" ]] && rmdir "$d"
498     [[ -h "$d" ]] && rm "$d"
499 done
500 ln -vsnfT "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
501     || fatal "symlink failed"
502 go get -v github.com/kardianos/govendor \
503     || fatal "govendor install failed"
504 cd "$GOPATH/src/git.curoverse.com/arvados.git" \
505     || fatal
506 # Remove cached source dirs in workdir. Otherwise, they won't qualify
507 # as +missing or +external below, and we won't be able to detect that
508 # they're missing from vendor/vendor.json.
509 rm -r vendor/*/
510 go get -v -d ...
511 "$GOPATH/bin/govendor" sync \
512     || fatal "govendor sync failed"
513 [[ -z $("$GOPATH/bin/govendor" list +unused +missing +external | tee /dev/stderr) ]] \
514     || fatal "vendor/vendor.json has unused or missing dependencies -- try:
515 * govendor remove +unused
516 * govendor add +missing +external
517 "
518 cd "$WORKSPACE"
519
520
521 setup_virtualenv "$VENVDIR" --python python2.7
522 . "$VENVDIR/bin/activate"
523
524 # Needed for run_test_server.py which is used by certain (non-Python) tests.
525 pip freeze 2>/dev/null | egrep ^PyYAML= \
526     || pip install PyYAML >/dev/null \
527     || fatal "pip install PyYAML failed"
528
529 # Preinstall forked version of libcloud, because nodemanager "pip install"
530 # won't pick it up by default.
531 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
532     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
533     || fatal "pip install apache-libcloud failed"
534
535 # We need an unreleased (as of 2017-08-17) llfuse bugfix, otherwise our fuse test suite deadlocks.
536 pip freeze | grep -x llfuse==1.2.0 || (
537     set -e
538     yes | pip uninstall llfuse || true
539     cython --version || fatal "no cython; try sudo apt-get install cython"
540     cd "$temp"
541     (cd python-llfuse 2>/dev/null || git clone https://github.com/curoverse/python-llfuse)
542     cd python-llfuse
543     git checkout 620722fd990ea642ddb8e7412676af482c090c0c
544     git checkout setup.py
545     sed -i -e "s:'1\\.2':'1.2.0':" setup.py
546     python setup.py build_cython
547     python setup.py install --force
548 ) || fatal "llfuse fork failed"
549 pip freeze | grep -x llfuse==1.2.0 || fatal "error: installed llfuse 1.2.0 but '$(pip freeze | grep llfuse)' ???"
550
551 # Deactivate Python 2 virtualenv
552 deactivate
553
554 declare -a pythonstuff
555 pythonstuff=(
556     sdk/pam
557     sdk/python
558     sdk/python:py3
559     sdk/cwl
560     services/dockercleaner:py3
561     services/fuse
562     services/nodemanager
563     tools/crunchstat-summary
564     )
565
566 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
567 # Otherwise, skip dependent tests.
568 PYTHON3=$(which python3)
569 if [[ ${?} = 0 ]]; then
570     setup_virtualenv "$VENV3DIR" --python python3
571 else
572     PYTHON3=
573     cat >&2 <<EOF
574
575 Warning: python3 could not be found. Python 3 tests will be skipped.
576
577 EOF
578 fi
579
580 # Reactivate Python 2 virtualenv
581 . "$VENVDIR/bin/activate"
582
583 # Note: this must be the last time we change PATH, otherwise rvm will
584 # whine a lot.
585 setup_ruby_environment
586
587 echo "PATH is $PATH"
588
589 if ! which bundler >/dev/null
590 then
591     gem install --user-install bundler || fatal 'Could not install bundler'
592 fi
593
594 retry() {
595     remain="${repeat}"
596     while :
597     do
598         if ${@}; then
599             if [[ "$remain" -gt 1 ]]; then
600                 remain=$((${remain}-1))
601                 title "Repeating ${remain} more times"
602             else
603                 break
604             fi
605         elif [[ "$retry" == 1 ]]; then
606             read -p 'Try again? [Y/n] ' x
607             if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
608             then
609                 break
610             fi
611         else
612             break
613         fi
614     done
615 }
616
617 do_test() {
618     case "${1}" in
619         apps/workbench_units | apps/workbench_functionals | apps/workbench_integration)
620             suite=apps/workbench
621             ;;
622         services/nodemanager | services/nodemanager_integration)
623             suite=services/nodemanager_suite
624             ;;
625         *)
626             suite="${1}"
627             ;;
628     esac
629     if [[ -z "${skip[$suite]}" && -z "${skip[$1]}" && \
630                 (-z "${only}" || "${only}" == "${suite}" || \
631                  "${only}" == "${1}") ]]; then
632         retry do_test_once ${@}
633     else
634         title "Skipping ${1} tests"
635     fi
636 }
637
638 do_test_once() {
639     unset result
640
641     title "Running $1 tests"
642     timer_reset
643     if [[ "$2" == "go" ]]
644     then
645         covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
646         coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
647         # We do "go get -t" here to catch compilation errors
648         # before trying "go test". Otherwise, coverage-reporting
649         # mode makes Go show the wrong line numbers when reporting
650         # compilation errors.
651         go get -t "git.curoverse.com/arvados.git/$1" && \
652             cd "$GOPATH/src/git.curoverse.com/arvados.git/$1" && \
653             [[ -z "$(gofmt -e -d . | tee /dev/stderr)" ]] && \
654             if [[ -n "${testargs[$1]}" ]]
655         then
656             # "go test -check.vv giturl" doesn't work, but this
657             # does:
658             go test ${short:+-short} ${testargs[$1]}
659         else
660             # The above form gets verbose even when testargs is
661             # empty, so use this form in such cases:
662             go test ${short:+-short} ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
663         fi
664         result=${result:-$?}
665         if [[ -f "$WORKSPACE/tmp/.$covername.tmp" ]]
666         then
667             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
668             rm "$WORKSPACE/tmp/.$covername.tmp"
669         fi
670     elif [[ "$2" == "pip" ]]
671     then
672         tries=0
673         cd "$WORKSPACE/$1" && while :
674         do
675             tries=$((${tries}+1))
676             # $3 can name a path directory for us to use, including trailing
677             # slash; e.g., the bin/ subdirectory of a virtualenv.
678             "${3}python" setup.py ${short:+--short-tests-only} test ${testargs[$1]}
679             result=$?
680             if [[ ${tries} < 3 && ${result} == 137 ]]
681             then
682                 printf '\n*****\n%s tests killed -- retrying\n*****\n\n' "$1"
683                 continue
684             else
685                 break
686             fi
687         done
688     elif [[ "$2" != "" ]]
689     then
690         "test_$2"
691     else
692         "test_$1"
693     fi
694     result=${result:-$?}
695     checkexit $result "$1 tests"
696     title "End of $1 tests (`timer`)"
697     return $result
698 }
699
700 do_install() {
701     if [[ -z "${only_install}" || "${only_install}" == "${1}" ]]; then
702         retry do_install_once ${@}
703     else
704         title "Skipping $1 install"
705     fi
706 }
707
708 do_install_once() {
709     title "Running $1 install"
710     timer_reset
711     if [[ "$2" == "go" ]]
712     then
713         go get -t "git.curoverse.com/arvados.git/$1"
714     elif [[ "$2" == "pip" ]]
715     then
716         # $3 can name a path directory for us to use, including trailing
717         # slash; e.g., the bin/ subdirectory of a virtualenv.
718
719         # Need to change to a different directory after creating
720         # the source dist package to avoid a pip bug.
721         # see https://arvados.org/issues/5766 for details.
722
723         # Also need to install twice, because if it believes the package is
724         # already installed, pip it won't install it.  So the first "pip
725         # install" ensures that the dependencies are met, the second "pip
726         # install" ensures that we've actually installed the local package
727         # we just built.
728         cd "$WORKSPACE/$1" \
729             && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
730             && cd "$WORKSPACE" \
731             && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
732             && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
733     elif [[ "$2" != "" ]]
734     then
735         "install_$2"
736     else
737         "install_$1"
738     fi
739     result=$?
740     checkexit $result "$1 install"
741     title "End of $1 install (`timer`)"
742     return $result
743 }
744
745 bundle_install_trylocal() {
746     (
747         set -e
748         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
749         if ! bundle install --local --no-deployment; then
750             echo "(Running bundle install again, without --local.)"
751             bundle install --no-deployment
752         fi
753         bundle package --all
754     )
755 }
756
757 install_doc() {
758     cd "$WORKSPACE/doc" \
759         && bundle_install_trylocal \
760         && rm -rf .site
761 }
762 do_install doc
763
764 install_gem() {
765     gemname=$1
766     srcpath=$2
767     with_test_gemset gem_uninstall_if_exists "$gemname" \
768         && cd "$WORKSPACE/$srcpath" \
769         && bundle_install_trylocal \
770         && gem build "$gemname.gemspec" \
771         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
772 }
773
774 install_ruby_sdk() {
775     install_gem arvados sdk/ruby
776 }
777 do_install sdk/ruby ruby_sdk
778
779 install_R_sdk() {
780     cd "$WORKSPACE/sdk/R" \
781        && R --quiet --vanilla <<EOF
782 options(repos=structure(c(CRAN="http://cran.wustl.edu/")))
783 if (!requireNamespace("devtools")) {
784   install.packages("devtools")
785 }
786 if (!requireNamespace("roxygen2")) {
787   install.packages("roxygen2")
788 }
789 devtools::install_dev_deps()
790 EOF
791 }
792 do_install sdk/R R_sdk
793
794 install_perl_sdk() {
795     cd "$WORKSPACE/sdk/perl" \
796         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
797         && make install INSTALLDIRS=perl
798 }
799 do_install sdk/perl perl_sdk
800
801 install_cli() {
802     install_gem arvados-cli sdk/cli
803 }
804 do_install sdk/cli cli
805
806 install_login-sync() {
807     install_gem arvados-login-sync services/login-sync
808 }
809 do_install services/login-sync login-sync
810
811 # Install the Python SDK early. Various other test suites (like
812 # keepproxy) bring up run_test_server.py, which imports the arvados
813 # module. We can't actually *test* the Python SDK yet though, because
814 # its own test suite brings up some of those other programs (like
815 # keepproxy).
816 for p in "${pythonstuff[@]}"
817 do
818     dir=${p%:py3}
819     if [[ ${dir} = ${p} ]]; then
820         if [[ -z ${skip[python2]} ]]; then
821             do_install ${dir} pip
822         fi
823     elif [[ -n ${PYTHON3} ]]; then
824         if [[ -z ${skip[python3]} ]]; then
825             do_install ${dir} pip "$VENV3DIR/bin/"
826         fi
827     fi
828 done
829
830 install_apiserver() {
831     cd "$WORKSPACE/services/api" \
832         && RAILS_ENV=test bundle_install_trylocal
833
834     rm -f config/environments/test.rb
835     cp config/environments/test.rb.example config/environments/test.rb
836
837     if [ -n "$CONFIGSRC" ]
838     then
839         for f in database.yml
840         do
841             cp "$CONFIGSRC/$f" config/ || fatal "$f"
842         done
843     fi
844
845     # Clear out any lingering postgresql connections to the test
846     # database, so that we can drop it. This assumes the current user
847     # is a postgresql superuser.
848     cd "$WORKSPACE/services/api" \
849         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
850         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
851
852     mkdir -p "$WORKSPACE/services/api/tmp/pids"
853
854     cert="$WORKSPACE/services/api/tmp/self-signed"
855     if [[ ! -e "$cert.pem" || "$(date -r "$cert.pem" +%s)" -lt 1512659226 ]]; then
856         (
857             dir="$WORKSPACE/services/api/tmp"
858             set -ex
859             openssl req -newkey rsa:2048 -nodes -subj '/C=US/ST=State/L=City/CN=localhost' -out "$cert.csr" -keyout "$cert.key" </dev/null
860             openssl x509 -req -in "$cert.csr" -signkey "$cert.key" -out "$cert.pem" -days 3650 -extfile <(printf 'subjectAltName=DNS:localhost,DNS:::1,DNS:0.0.0.0,DNS:127.0.0.1,IP:::1,IP:0.0.0.0,IP:127.0.0.1')
861         ) || return 1
862     fi
863
864     cd "$WORKSPACE/services/api" \
865         && rm -rf tmp/git \
866         && mkdir -p tmp/git \
867         && cd tmp/git \
868         && tar xf ../../test/test.git.tar \
869         && mkdir -p internal.git \
870         && git --git-dir internal.git init \
871             || return 1
872
873     cd "$WORKSPACE/services/api" \
874         && RAILS_ENV=test bundle exec rake db:drop \
875         && RAILS_ENV=test bundle exec rake db:setup \
876         && RAILS_ENV=test bundle exec rake db:fixtures:load
877 }
878 do_install services/api apiserver
879
880 declare -a gostuff
881 gostuff=(
882     cmd/arvados-client
883     lib/cli
884     lib/cmd
885     lib/crunchstat
886     sdk/go/arvados
887     sdk/go/arvadosclient
888     sdk/go/blockdigest
889     sdk/go/dispatch
890     sdk/go/health
891     sdk/go/httpserver
892     sdk/go/manifest
893     sdk/go/asyncbuf
894     sdk/go/crunchrunner
895     sdk/go/stats
896     services/arv-git-httpd
897     services/crunchstat
898     services/health
899     services/keep-web
900     services/keepstore
901     sdk/go/keepclient
902     services/keep-balance
903     services/keepproxy
904     services/crunch-dispatch-local
905     services/crunch-dispatch-slurm
906     services/crunch-run
907     services/ws
908     tools/keep-block-check
909     tools/keep-exercise
910     tools/keep-rsync
911     tools/sync-groups
912 )
913 for g in "${gostuff[@]}"
914 do
915     do_install "$g" go
916 done
917
918 install_workbench() {
919     cd "$WORKSPACE/apps/workbench" \
920         && mkdir -p tmp/cache \
921         && RAILS_ENV=test bundle_install_trylocal \
922         && RAILS_ENV=test RAILS_GROUPS=assets bundle exec rake npm:install
923 }
924 do_install apps/workbench workbench
925
926 unset http_proxy https_proxy no_proxy
927
928 test_doclinkchecker() {
929     (
930         set -e
931         cd "$WORKSPACE/doc"
932         ARVADOS_API_HOST=qr1hi.arvadosapi.com
933         # Make sure python-epydoc is installed or the next line won't
934         # do much good!
935         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
936     )
937 }
938 do_test doc doclinkchecker
939
940 stop_services
941
942 test_apiserver() {
943     rm -f "$WORKSPACE/services/api/git-commit.version"
944     cd "$WORKSPACE/services/api" \
945         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
946 }
947 do_test services/api apiserver
948
949 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
950 # because we don't need to start up the api server for subsequent tests.
951 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
952   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
953   exit_cleanly
954 fi
955
956 start_services || { stop_services; fatal "start_services"; }
957
958 test_ruby_sdk() {
959     cd "$WORKSPACE/sdk/ruby" \
960         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
961 }
962 do_test sdk/ruby ruby_sdk
963
964 test_R_sdk() {
965     cd "$WORKSPACE/sdk/R" \
966         && R --quiet --file=run_test.R
967 }
968 do_test sdk/R R_sdk
969
970 test_cli() {
971     cd "$WORKSPACE/sdk/cli" \
972         && mkdir -p /tmp/keep \
973         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
974 }
975 do_test sdk/cli cli
976
977 test_login-sync() {
978     cd "$WORKSPACE/services/login-sync" \
979         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
980 }
981 do_test services/login-sync login-sync
982
983 test_nodemanager_integration() {
984     cd "$WORKSPACE/services/nodemanager" \
985         && tests/integration_test.py ${testargs[services/nodemanager_integration]}
986 }
987 do_test services/nodemanager_integration nodemanager_integration
988
989 for p in "${pythonstuff[@]}"
990 do
991     dir=${p%:py3}
992     if [[ ${dir} = ${p} ]]; then
993         if [[ -z ${skip[python2]} ]]; then
994             do_test ${dir} pip
995         fi
996     elif [[ -n ${PYTHON3} ]]; then
997         if [[ -z ${skip[python3]} ]]; then
998             do_test ${dir} pip "$VENV3DIR/bin/"
999         fi
1000     fi
1001 done
1002
1003 for g in "${gostuff[@]}"
1004 do
1005     do_test "$g" go
1006 done
1007
1008 test_workbench_units() {
1009     cd "$WORKSPACE/apps/workbench" \
1010         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:units TESTOPTS=-v ${testargs[apps/workbench]}
1011 }
1012 do_test apps/workbench_units workbench_units
1013
1014 test_workbench_functionals() {
1015     cd "$WORKSPACE/apps/workbench" \
1016         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:functionals TESTOPTS=-v ${testargs[apps/workbench]}
1017 }
1018 do_test apps/workbench_functionals workbench_functionals
1019
1020 test_workbench_integration() {
1021     cd "$WORKSPACE/apps/workbench" \
1022         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:integration TESTOPTS=-v ${testargs[apps/workbench]}
1023 }
1024 do_test apps/workbench_integration workbench_integration
1025
1026
1027 test_workbench_benchmark() {
1028     cd "$WORKSPACE/apps/workbench" \
1029         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
1030 }
1031 do_test apps/workbench_benchmark workbench_benchmark
1032
1033 test_workbench_profile() {
1034     cd "$WORKSPACE/apps/workbench" \
1035         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:profile ${testargs[apps/workbench_profile]}
1036 }
1037 do_test apps/workbench_profile workbench_profile
1038
1039 exit_cleanly